#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <math.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"


GtkWidget *nb_file_selector;
GtkWidget *nb_text;
GtkWidget *nb_appbar1;


gchar *nb_text_buff; /* used with fuction which allocates memory automatically */
gchar *selected_filename = NULL;
gboolean soundfile=FALSE;


  FILE *stream, *temp_stream, *outputstream;
  long int sample_number = 0;
  long int total_length = 0;
  int j=0, i=0;
  float a,b,q,t=0;
  float duration = DURATION;
  float scale_factor = SCALE_FACTOR;
  float fft_thres = FFT_THRESHOLD;
  float temp_val =0;
  float freq[MAX_ARRAY_SIZE], ampl[MAX_ARRAY_SIZE];
  long int array_size=0;
  float hash;
  double sample;
  double sample_min=0, sample_max=0;
  char *temp_filename;


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

  /* some inits */
  sample_number = 0;
  total_length = 0;
  j=0;
  i=0;
  t=0;

  temp_val =0;
  array_size=0;
  sample_min=0;
  sample_max=0;



  if (nb_text == NULL)
    nb_text = lookup_widget(GTK_MENU_ITEM (menuitem), "text1"); 

  if (nb_appbar1 == NULL)
    nb_appbar1 = lookup_widget(GTK_MENU_ITEM (menuitem), "appbar1"); 

  gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL,
                   _("Opening file.. \n"), -1);



  nb_file_selector = gtk_file_selection_new ("Please select a .dat file");

  gtk_file_selection_set_filename (GTK_FILE_SELECTION(nb_file_selector),
				   DATA_PATH);
  gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION(nb_file_selector));

  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(nb_file_selector)->ok_button),
		      "clicked", GTK_SIGNAL_FUNC (store_filename), NULL);
                             
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(nb_file_selector)->ok_button),
			     "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     (gpointer) nb_file_selector);
  
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(nb_file_selector)->cancel_button),
			     "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     (gpointer) nb_file_selector);
  
  gtk_widget_show (nb_file_selector);

}


void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  g_free(nb_text_buff);
  g_free(selected_filename);
  gtk_main_quit();

}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  /* ABOUT MENU */

  const gchar *authors[] =
    { "Niels Bassler <bassler@phys.au.dk>",
      "Institute of Physics and Astronomy (IFA)",
      "University of Aarhus, Denmark"
    , NULL
  };

  GtkWidget *about;

  about = gnome_about_new ("Gnome Fnix", VERSION, "17.10.2002 Institute of Physics and Astronomy", authors,
			   _("Gnome Fnix converts a FFT spectrum to an audio file.\n"
			     "http://astro.phys.au.dk/Roemer"),NULL);  
  gtk_widget_show (GTK_WIDGET(about));

}


void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  /* OPEN BUTTON */

  nb_text = lookup_widget(GTK_BUTTON (button), "text1"); 
  nb_appbar1 = lookup_widget(GTK_BUTTON (button), "appbar1");
  on_open1_activate(GTK_BUTTON (button), NULL);
  
}


void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  /* ----------- PROCESS BUTTON -------------- */

  GtkWidget *my_spinbutton;

  soundfile = FALSE;

  if (selected_filename == NULL)
    gnome_error_dialog("No input file selected.\n"); 
  else {
    /* get state of widgets */ 
    my_spinbutton = lookup_widget(GTK_BUTTON (button), "spinbutton1");  
    fft_thres = gtk_spin_button_get_value_as_float (my_spinbutton);
    my_spinbutton = lookup_widget(GTK_BUTTON (button), "spinbutton3");  
    scale_factor = gtk_spin_button_get_value_as_float (my_spinbutton);
    my_spinbutton = lookup_widget(GTK_BUTTON (button), "spinbutton2");  
    duration = gtk_spin_button_get_value_as_float (my_spinbutton);
    
    nb_text = lookup_widget(GTK_BUTTON (button), "text1"); 
    gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL,
		     _("  Now processing.. \n"), -1);
    
    
    nb_text_buff = g_strdup_printf ("   - FFT_Threshold: %.3f\n   - Scale Factor: %.0f\n   - Duration: %.0f seconds\n", fft_thres, scale_factor, duration);
    gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(nb_text_buff), -1);
    gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(selected_filename), -1);
    gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _("\n"), -1);
    j = 0;
    /* rereading array */
    temp_val = 2 * M_PI * (0.000001 * scale_factor);
    stream = fopen(selected_filename, "r");
    while ((fscanf(stream,"%f %f",&a,&b)) 
	   && (!feof(stream)))
    {
      if (b > fft_thres) {	
	
	freq[j] = a * temp_val;
	ampl[j] = b;
	 j++;
	 if ( j > MAX_ARRAY_SIZE ) {
	   g_error( " Error: input data file too large.\n");
	   exit(1);
	 }
	 /* nb_text_buff er halv-global */
	 /* Verbose */
	 /*	 nb_text_buff = g_strdup_printf ("  %f %f\n", a,b);
		 gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(nb_text_buff), -1);*/
      }
    }
    fclose(stream);
    array_size = j;

    nb_text_buff = g_strdup_printf ("   Array size: %d\n", j);
    gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(nb_text_buff), -1);
    
    nb_text_buff = NULL; 

    do_calc();

    gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, 
		   _("   Now converting to a WAV file..."), -1);
    
    while(gtk_events_pending())  /* Flushing */
      gtk_main_iteration();
    
    system(WAVECONVERTER);
    remove("out.dat");
    gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, 
		     _("   Done!\n\n"), -1);
    gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, 
		     _("   Ready to play.\n"), -1);

    soundfile = TRUE;
    
  }
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  g_free(nb_text_buff);
  g_free(selected_filename);
  gtk_main_quit();
}



/* nb stuff */ 
void store_filename(GtkFileSelection *selector, gpointer user_data) 
{

  selected_filename = (gchar *) g_malloc(strlen(gtk_file_selection_get_filename (GTK_FILE_SELECTION(nb_file_selector))));
  strcpy(selected_filename, 
	 gtk_file_selection_get_filename (GTK_FILE_SELECTION(nb_file_selector)));

  nb_text_buff = g_strconcat ("\nLoading file : ",selected_filename,"\n", NULL) ;

  gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(nb_text_buff), -1);



 /* reading array */
  temp_val = 2 * M_PI * (0.000001 * scale_factor);
  stream = fopen(selected_filename, "r");
  while ((fscanf(stream,"%f %f",&a,&b)) 
	 && (!feof(stream)))
    {
       if (b > fft_thres) {	
	 
	 freq[j] = a * temp_val;
	 ampl[j] = b;
	 j++;
	 if ( j > MAX_ARRAY_SIZE ) {
	   g_error( " Error: input data file too large.\n");
	   exit(1);
	 }
	 /* nb_text_buff er halv-global */
	 nb_text_buff = g_strdup_printf ("  %f %f\n", a,b);
	 gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(nb_text_buff), -1);


       }
    }
  fclose(stream);
  array_size = j;

  nb_text_buff = g_strdup_printf ("   Array size: %d\n   Ready for processing.", j);
  gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(nb_text_buff), -1);

  nb_text_buff = NULL; 
  /* paranoid */
  if (nb_appbar1 == NULL)
    g_error("Could not find appbar1.");
  gnome_appbar_set_default( GTK_WIDGET (nb_appbar1), selected_filename);
  gnome_appbar_refresh( GTK_WIDGET (nb_appbar1));
}




int do_calc(void) {

  /* some inits */
  sample_number = 0;
  total_length = 0;
  t=0;
  i=0;
  sample_min=0;
  sample_max=0;

  total_length = (long int) SAMPLE_RATE * duration;

  /* First run to detect limits, without normalization */
  gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _("   Processing..."), -1);
  
  /* get a template file*/
  /* (No, I do not b***** care about the warnings!) */
  temp_filename = tmpnam(NULL);
  temp_stream = fopen(temp_filename, "w");

  if (temp_stream == NULL) {
    g_error("Cannot open temp file.\n");
    exit(1);
  }


  while (sample_number <  total_length) {
    /* clear sample value */
    sample = 0;
    t = (float) sample_number / SAMPLE_RATE;

    /* CHANNEL 1 */
    for (j=0; j < array_size; ++j) 
      {
	/* single increement, use all numbers */
	q = ampl[j] * sin( (float) freq[j] * t);
	sample += q; 
	if (sample > OVERFLOW_PROTECTION)
	  {
	    g_error("OOOOPS: %f --- %f %f %f %f",(float) sample,a,b,t,q);
	    exit(1);
	  }
      }

    /* check and record limits */
    if (sample > sample_max)
      sample_max = sample;
    if (sample < sample_min)
      sample_min = sample;

    fprintf(temp_stream,"%f %.12f\n",t,sample); 

    /* the mono channel have now been written to the temp file. */
    /* next sample */
    ++i;

    if (i > HASH_MARKS) {
      hash =  ( (float) sample_number) / total_length;
      /* Old verbose version */
      /*      nb_text_buff = g_strdup_printf ("     %.1f %%\n", hash*100);
	      gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(nb_text_buff), -1);*/
      i = 0;

      /* update the progress bar */
      gnome_appbar_set_progress(GTK_WIDGET (nb_appbar1), (gfloat) hash);
      while(gtk_events_pending())  /* Flushing */
	gtk_main_iteration();
      
    }   
    sample_number++;
  }

  fclose(temp_stream);
  /* set appbar to 1, for aestetics */
  gnome_appbar_set_progress(GTK_WIDGET (nb_appbar1), 1.0);

  nb_text_buff = g_strdup_printf ("   MAX/MIN: %f / %f\n", sample_max,sample_min);
  gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(nb_text_buff), -1);


  if (fabs(sample_min) > fabs(sample_max))
    sample_max = sample_min;


  /* ------------------- */
  /*   now normalize it: */
  /* --------------------*/

  /* g_print("  %s  ",temp_filename);*/
  gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, 
		   _("   Normalizing ... (this may take some time)"), -1);
     
  while(gtk_events_pending())  /* Flushing */
    gtk_main_iteration();

  temp_stream = fopen(temp_filename, "r");
  outputstream = fopen ("out.dat", "w");
  fprintf(outputstream, "; Sample Rate %i\n", SAMPLE_RATE);


  while (!feof(temp_stream)) {
    /* CHANNEL 1 */
    fscanf(temp_stream,"%f %f", &t, &b);
    /* Why is this neccessary ? (Very spooky!)*/ 
    sample = b;
    /*        printf("1.  %f %f\n",t,sample);*/
    sample /= sample_max;
    fprintf(outputstream,"%f %.12f\n",t,sample);  
    
  }

  fclose(temp_stream);
  fclose(outputstream);
  remove(temp_filename);

  gtk_text_insert (GTK_TEXT (nb_text), NULL, NULL, NULL, _(" Done! \n   Output written to out.dat\n"), -1);
  return(0);
}

void
on_checkbutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  gnome_error_dialog("Function not implemented yet!\n"); 
}


void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  if (soundfile)
    system(PLAYER);
  else
    gnome_error_dialog("No file has been processed!\n");  
}




